import { ElementRef, EventEmitter, NgZone, Renderer } from '@angular/core';
import { Backdrop } from '../backdrop/backdrop';
import { Config } from '../../config/config';
import { Keyboard } from '../../util/keyboard';
import { MenuController } from './menu-controller';
import { Platform } from '../../platform/platform';
import { GestureController } from '../../gestures/gesture-controller';
import { Content } from '../content/content';
export declare class Menu {
    _menuCtrl: MenuController;
    private _elementRef;
    private _config;
    private _platform;
    private _renderer;
    private _keyboard;
    private _zone;
    private _gestureCtrl;
    private _cntEle;
    private _cntGesture;
    private _type;
    private _isEnabled;
    private _isSwipeEnabled;
    private _isAnimating;
    private _isPers;
    private _init;
    private _events;
    private _gestureID;
    isOpen: boolean;
    backdrop: Backdrop;
    menuContent: Content;
    content: any;
    id: string;
    side: string;
    type: string;
    enabled: boolean;
    swipeEnabled: boolean;
    persistent: boolean;
    maxEdgeStart: number;
    ionDrag: EventEmitter<number>;
    ionOpen: EventEmitter<boolean>;
    ionClose: EventEmitter<boolean>;
    constructor(_menuCtrl: MenuController, _elementRef: ElementRef, _config: Config, _platform: Platform, _renderer: Renderer, _keyboard: Keyboard, _zone: NgZone, _gestureCtrl: GestureController);
    ngOnInit(): void;
    onBackdropClick(ev: UIEvent): boolean;
    private _setListeners();
    private _getType();
    setOpen(shouldOpen: boolean, animated?: boolean): Promise<boolean>;
    canSwipe(): boolean;
    swipeStart(): void;
    swipeProgress(stepValue: number): void;
    swipeEnd(shouldCompleteLeft: boolean, shouldCompleteRight: boolean, stepValue: number): void;
    private _before();
    private _after(isOpen);
    open(): Promise<boolean>;
    close(): Promise<boolean>;
    toggle(): Promise<boolean>;
    enable(shouldEnable: boolean): Menu;
    swipeEnable(shouldEnable: boolean): Menu;
    getNativeElement(): HTMLElement;
    getMenuElement(): HTMLElement;
    getContentElement(): HTMLElement;
    getBackdropElement(): HTMLElement;
    width(): number;
    getMenuController(): MenuController;
    setElementClass(className: string, add: boolean): void;
    setElementAttribute(attributeName: string, value: string): void;
    ngOnDestroy(): void;
}
